package ru.dbotthepony.kstarbound.world.entities.behavior

import com.google.common.collect.ImmutableList
import org.classdump.luna.runtime.ExecutionContext
import ru.dbotthepony.kstarbound.lua.userdata.BehaviorState

class RandomizeNode(val children: ImmutableList<AbstractBehaviorNode>) : AbstractBehaviorNode() {
	var index = -1

	override fun run(delta: Double, state: BehaviorState): Status {
		if (index == -1 && children.isNotEmpty())
			index = state.lua.random.nextInt(children.size)

		if (index == -1)
			return Status.FAILURE

		return children[index].runAndReset(delta, state)
	}

	override fun reset() {
		children.forEach { it.reset() }
		index = -1
	}
}
