package ru.dbotthepony.kstarbound.world.entities.behavior

import com.google.common.collect.ImmutableList
import org.classdump.luna.runtime.ExecutionContext
import ru.dbotthepony.kstarbound.lua.userdata.BehaviorState

class SequenceNode(val children: ImmutableList<AbstractBehaviorNode>) : AbstractBehaviorNode() {
	private var index = 0

	override fun run(delta: Double, state: BehaviorState): Status {
		while (index < children.size) {
			val child = children[index]
			val status = child.runAndReset(delta, state)

			if (status == Status.FAILURE || status == Status.RUNNING)
				return status

			index++
		}

		return Status.SUCCESS
	}

	override fun reset() {
		children.forEach { it.reset() }
		index = 0
	}
}
